// dmsDate.cpp: implementation of the CdmsDate class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "dmsDate.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
const char monthes[]={31,28,31,30,31,30,31,31,30,31,30,31};
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CdmsDate::CdmsDate()
{

	day=1;
	month=1;
	year=1;
}

CdmsDate::~CdmsDate()
{

}
CdmsDate::CdmsDate(char tday, char tmonth,int tyear)
	{
		SetDate(tday,tmonth,tyear);
	}
CdmsDate::CdmsDate(const CdmsDate& d)
{
	day=d.day;
	month=d.month;
	year=d.year;
}
CdmsDate::CdmsDate(const char* in)
{
	SetDateStr(in);

}
CdmsDate::SetDay(char tDay)
	{
		day=tDay;
		if(!CheckParity()) throw Error();
	}
CdmsDate::SetMonth(char tMonth)
	{
		month=tMonth;
		if(!CheckParity()) throw Error();
	}
CdmsDate::SetYear(int tYear)
	{
		year=tYear;
		if(!CheckParity()) throw Error();
	}


void CdmsDate::SetDateStr(const char* in)
{
	const	char* tmp=in;
	char ogranich=2;
	day=0;
	while(isdigit(*tmp)&&ogranich)
	{
		day*=10;
		day+=(*tmp)-48;
		tmp++;
		ogranich--;
	}
	// tmp   
	tmp++;
	ogranich=2;
	month=0;
	while(isdigit(*tmp)&&ogranich)
	{
		month*=10;
		month+=*tmp-48;
		tmp++;
		ogranich--;
	}
	//tmp s    ()
	tmp++;
	ogranich=4;
	year=0;
	while(isdigit(*tmp)&&ogranich)
	{
		year*=10;
		year+=*tmp-48;
		tmp++;
		ogranich--;
	}
	
		if(!CheckParity()) throw Error();
}
void CdmsDate::SetDate(char tday, char tmonth,int tyear)
{
		day=tday;
		month=tmonth;
		year=tyear;
		if(!CheckParity()) throw Error();
}

const char* CdmsDate::tstr()
	{
		sprintf(tstrbuf,"%d.%d.%d",day,month,year);
		return tstrbuf;
	}
bool CdmsDate::operator==(const CdmsDate& d)
{
	return ((day==d.day)&&(month==d.month)&&(year==d.year));
}
bool CdmsDate::operator!=(const CdmsDate& d)
{
	return ((day!=d.day)||(month!=d.month)||(year!=d.year));
}
bool CdmsDate::operator>(const CdmsDate& d)
{
	if(year==d.year)
	{
		if(month==d.month)
		{
			return day>d.day;
		}
		else return month>d.month;
	}
	else
		return year>d.year;
}
bool CdmsDate::operator<(const CdmsDate& d)
{
	if(year==d.year)
	{
		if(month==d.month)
		{
			return day<d.day;
		}
		else return month<d.month;
	}
	else
		return year<d.year;
}
bool CdmsDate::operator<=(const CdmsDate& d)
{
	if(year==d.year)
	{
		if(month==d.month)
		{
			return day<=d.day;
		}
		else return month<=d.month;
	}
	else
		return year<=d.year;
}
bool CdmsDate::operator>=(const CdmsDate& d)
{
	if(year==d.year)
	{
		if(month==d.month)
		{
			return day>=d.day;
		}
		else return month>=d.month;
	}
	else
		return year>=d.year;
}
CdmsDate& CdmsDate::operator+=(const CdmsDate& d)
{
	year+=d.year;
	month+=d.month%13;//      13   .
	year+=d.month/13;// ,   9   5 .
	day+=d.day;
	if(CheckYear(year)&&month==2)// ,      - 
	{
		if(day>29)
		{
			day-=29;
			month++;//   
		}

	
	}
	else
	{
		if(day>monthes[month-1])//      
		{
			day-=monthes[month-1];
			month++;
			if(month==13)
			{
				month=1;
				year++;
			}
		}
	}
	return *this;
}
CdmsDate& CdmsDate::operator-=(const CdmsDate& d)
{
	year-=d.year;
	month-=d.month;
	if(month=0)
	{//      13   .
		month=12;
		year--;// ,   2   5 .
	}
	day-=d.day;
	if(CheckYear(year)&&month==2)// ,      - 
	{
		if(day<1)
		{
			day+=29;
			month--;//   
		}

	
	}
	else
	{
		if(day<1)//  .
		{
			month--;
			if(month==0)
			{
				month=12;
				year--;
			}
			day+=monthes[month-1];//    -    .
		}
	}
	return *this;
}
CdmsDate& CdmsDate::operator+=(int a)
{
	char nDayInCurMonth=0;
	nDayInCurMonth=monthes[month-1];
	if(month==2&&CheckYear(year)) nDayInCurMonth++;
	while(a+day>nDayInCurMonth)
	{
		a-=nDayInCurMonth-day;
		day=0;//   .
		month++;
		if(month==13)
		{
			month=1;
			year++;
		}
	nDayInCurMonth=monthes[month-1];
	if(month==2&&CheckYear(year)) nDayInCurMonth++;
	}
	day+=a;//    ,   ;
	return *this;
}
CdmsDate& CdmsDate::operator-=(int a)
{
	char nDayInCurMonth=0;
	while(a>day)
	{
		a-=day;

		
		month--;
		if(month==0)
		{
			month=12;
			year--;
		}
		nDayInCurMonth=monthes[month-1];
		if(month==2&&CheckYear(year)) nDayInCurMonth++;
		day=nDayInCurMonth;
	}
	day-=a;//    ,   ;
	if(day==0)
	{
		month--;
		if(month==0)
		{
			year--;
			month=12;
		}
		if(month==2&&CheckYear(year))
			day=29;
		else
			day=monthes[month-1];
	}
	return *this;
}
bool CheckYear(int year)//  ,     4,       100,      400
{
	if(year%4==0)
	{
		if(year%100==0)
		{
			if(year%400==0)
				return true;
				else
				return false;
		}
		else
			return true;
	}
	else return false;
}
CdmsDate operator+(const CdmsDate& a, const CdmsDate& b)
{
	CdmsDate Temp(a);
	Temp+=b;
	return Temp;
}
CdmsDate operator+(const CdmsDate& a, int b)
{
	CdmsDate Temp(a);
	Temp+=b;
	return Temp;
}
CdmsDate operator-(const CdmsDate& a, int d)
{
	CdmsDate Temp(a);
	Temp-=d;
	return Temp;
}
int operator-(const CdmsDate& a, const CdmsDate& d)
{
	unsigned int dd1=0;//         
	for(char i=0;i<d.month-1;i++)//        ,   .
	{
		dd1+=monthes[i];//    -    .
	}
	dd1+=d.day;
	if(CheckYear(d.year)&&d.month>2)
		dd1++;//  ,  -   1.
	
	unsigned int dd22=0;//         
	for(i=0;i<a.month-1;i++)//        ,   .
	{
		dd22+=monthes[i];//    -    .
	}
	dd22+=a.day;
	if(CheckYear(a.year)&&a.month>2)
		dd22++;//  ,  -   1.
	
	unsigned int dd12=0;//        .
	if(d.year<a.year)//   
	{
		for(int i=d.year;i<a.year;i++)
		{
			if(CheckYear(i)) dd12+=366;
			else dd12+=365;
		}
		return dd12+dd22-dd1;
	}
	else//     
	{
		for(int i=a.year;i<d.year;i++)
		{
			if(CheckYear(i)) dd12+=366;
			else dd12+=365;
		}
		return dd22-dd12-dd1;//-1 ,            .
	}
}
/*      int operator-(const CdmsDate& a,const CdmsDate& b);
//   CdmsDate operator-=(const CdmsDate& d);
CdmsDate operator-(const CdmsDate& a, const CdmsDate& b)
{
	CdmsDate Temp(a);
	Temp-=b;
	return Temp;
}
*/

bool CdmsDate::CheckParity()
{
	if(year<=0) return false;
	if(month<1||month>12) return false;
	char nDay=monthes[month-1];
	if(month==2&&CheckYear(year)) nDay++;
	if(day<1||day>nDay)return false;
	return true;

}
